#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    //cin >> q;
    while (q--) {
        solve();
    }
}

void solve() {
    ll n, m, k;
    cin >> n >> m >> k;
    vector<vector<ll>> g(n);
    for (int i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<ll> dp(n), used(n);
    for (int i = 0; i < k; i++) {
        ll p, h;
        cin >> p >> h;
        p--;
        dp[p] = max(dp[p], h);
    }
    queue<ll> bfs;
    for (int i = 0; i < n; i++) {
        if (dp[i] != 0) {
            bfs.push(i);
            used[i] = 1;
        }
    }
    while (!empty(bfs)) {
        ll v = bfs.front();
        bfs.pop();
        if (dp[v] == 0) {
            continue;
        }
        for (auto u : g[v]) {
            dp[u] = max(dp[u], dp[v] - 1);
            if (!used[u]) {
                used[u] = 1;
                bfs.push(u);
            }
        }
    }
    vector<ll> ans;
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            ans.push_back(i + 1);
        }
    }
    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i << ' ';
    }
}
