#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    //cin >> q;
    while (q--) {
        solve();
    }
}

vector<ll> color;
ll cur = 0;
void dfs(ll v, vector<ll>& used, vector<vector<ll>>& g) {
    used[v] = 1;
    color[v] = cur;
    for (auto u : g[v]) {
        if (!used[u]) {
            dfs(u, used, g);
        }
    }
}

void solve() {
    ll n, m, k;
    cin >> n >> m >> k;
    vector<vector<ll>> g(n);
    for (int i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    color.resize(n);
    vector<ll> us(n);
    for (int i = 0; i < n; i++) {
        if (!us[i]) {
            dfs(i, us, g);
            cur++;
        }
    }
    vector<ll> c(cur, -1);
    vector<ll> dp(n, -1), used(n);
    for (int i = 0; i < k; i++) {
        ll p, h;
        cin >> p >> h;
        p--;
        if (c[color[p]] == -1 || dp[c[color[p]]] < h) {
            c[color[p]] = p;
        }
        dp[p] = h;
    }
    queue<ll> bfs;
    for (auto i : c) {
        if (i == -1) {
            continue;
        }
        used[i] = 1;
        bfs.push(i);
    }
    while (!empty(bfs)) {
        ll v = bfs.front();
        bfs.pop();
        for (auto u : g[v]) {
            dp[u] = max(dp[u], dp[v] - 1);
            if (!used[u] && dp[u] >= 0) {
                used[u] = 1;
                bfs.push(u);
            }
        }
    }
    vector<ll> ans;
    for (int i = 0; i < n; i++) {
        if (used[i]) {
            ans.push_back(i + 1);
        }
    }
    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i << ' ';
    }
}
