#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    //cin >> q;
    while (q--) {
        solve();
    }
}


void solve() {
    ll n, m, k;
    cin >> n >> m >> k;
    vector<vector<ll>> g(n);
    for (int i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<ll> dp(n, -1);
    set<ll> bfs;
    for (int i = 0; i < k; i++) {
        ll p, h;
        cin >> p >> h;
        p--;
        dp[p] = h;
        bfs.insert(p);
    }
    while (!empty(bfs)) {
        ll v = *bfs.begin();
        bfs.erase(bfs.begin());
        for (auto u : g[v]) {
            if (dp[u] < dp[v] - 1) {
                bfs.erase(u);
                bfs.insert(u);
                dp[u] = dp[v] - 1;
            }
        }
    }
    vector<ll> ans;
    for (int i = 0; i < n; i++) {
        if (dp[i] > -1) {
            ans.push_back(i + 1);
        }
    }
    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i << ' ';
    }
}
