#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    //cin >> q;
    while (q--) {
        solve();
    }
}

void solve() {
    ll a, b;
    cin >> a >> b;
    ll g = gcd(a, b);
    a /= g;
    b /= g;
    pair<ll, ll> t = {a, b};
    map<pair<ll, ll>, pair<pair<ll, ll>, char>> pred;
    pred[{1, 1}] = {{-1, -1}, 'R'};
    vector<pair<ll, ll>> cur = {{0, 1}, {1, 1}, {1, 0}};
    for (int i1 = 0; i1 < 20; i1++) {
        vector<pair<ll, ll>> next;
        for (int i = 0; i < cur.size() - 1; i++) {
            next.emplace_back(cur[i]);
            next.emplace_back(cur[i].first + cur[i + 1].first, cur[i].second + cur[i + 1].second);
        }
        next.emplace_back(cur.back());
        for (int i = 1; i < next.size(); i += 4) {
            pred[next[i]] = {next[i + 1], 'L'};
            pred[next[i + 2]] = {next[i + 1], 'R'};
        }
        bool f = false;
        for (auto i : next) {
            if (i == t) {
                f = true;
            }
        }
        if (f) {
            break;
        }
        cur = next;
    }
    if (pred.find({a, b}) == pred.end()) {
        cout << "no";
        return;
    }
    string ans;
    while (a != -1) {
        ans += pred[{a, b}].second;
        ll x = pred[{a, b}].first.first, y = pred[{a, b}].first.second;
        a = x, b = y;
    }
    reverse(ans.begin(), ans.end());
    cout << ans;
}
