#include <bits/stdc++.h>

using namespace std;
using ll = long long;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    //cin >> q;
    while (q--) {
        solve();
    }
}


void solve() {
    ll n, m, k;
    cin >> n >> m >> k;
    vector<vector<ll>> g(n);
    for (int i = 0; i < m; i++) {
        ll a, b;
        cin >> a >> b;
        a--, b--;
        g[a].push_back(b);
        g[b].push_back(a);
    }
    vector<ll> dp(n, -1);
    set<pair<ll, ll>> dj;
    for (int i = 0; i < k; i++) {
        ll p, h;
        cin >> p >> h;
        p--;
        dp[p] = h;
        dj.insert({h, p});
    }
    while (!empty(dj)) {
        ll v = dj.begin()->second, w = dj.begin()->first;
        dj.erase(dj.begin());
        for (auto u : g[v]) {
            if (dp[u] < w - 1) {
                dj.erase({dp[u], u});
                dp[u] = w - 1;
                dj.insert({dp[u], u});
            }
        }
    }
    vector<ll> ans;
    for (int i = 0; i < n; i++) {
        if (dp[i] > -1) {
            ans.push_back(i + 1);
        }
    }
    cout << ans.size() << '\n';
    for (auto i : ans) {
        cout << i << ' ';
    }
}
