#include <bits/stdc++.h>

using namespace std;
using ll = long long;
using ld = long double;

void solve();

int main() {
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    int q = 1;
    //cin >> q;
    while (q--) {
        solve();
    }
}

struct vec {
    ld x, y;
};

vec rev(vec a) {
    return {a.y, -a.x};
}

struct line {
    ld a, b, c;
};

line get(vec a, vec b) {
    return {a.y - b.y, b.x - a.x, a.x * b.y - a.y * b.x};
}

vec per(line l1, line l2) {
    ld a1 = l1.a, b1 = l1.b, c1 = l1.c;
    ld a2 = l2.a, b2 = l2.b, c2 = l2.c;
    ld x = (c1 * b2 - b1 * c2) / (a2 * b1 - a1 * b2);
    ld y = (a2 * c1 - a1 * c2) / (a1 * b2 - a2 * b1);
    return {x, y};
}

ld dist(vec a, vec b) {
    return hypotl(a.x - b.x, a.y - b.y);
}

void solve() {
    vec a, b;
    cin >> a.x >> a.y >> b.x >> b.y;
    ld x = dist(a, b) / sqrtl(2);
    cout << fixed << setprecision(9);
    cout << x + x;
}
